/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.entity;

import java.sql.Types;

import org.hibernate.annotations.JdbcTypeCode;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Lob;
import jakarta.persistence.Table;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
@Entity(name = "ScriptEntity")
@Table(name = "script")
public class ScriptEntity extends AbstractBaseEntity {

	private static final long serialVersionUID = 1L;

	@Column(name = "script_text")
	@Lob
	@JdbcTypeCode(Types.LONGVARCHAR)	
	private String script;
	
	@Column(name = "script_type", length = 32)
	private String scriptType;
	
	@Column(name = "script_engine", length = 64)
	private String scriptEngine;
	
	@Column(name = "name", length = 128)
	private String name;
}
