/*******************************************************************************
 * Copyright (c) 2014 Michael Simon.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Michael Simon - initial
 ******************************************************************************/
package edu.kit.scc.webreg.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Table;
import jakarta.persistence.UniqueConstraint;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
@Entity(name = "TextPropertyEntity")
@Table(name = "text_property", 
	uniqueConstraints = @UniqueConstraint(columnNames = {"text_key", "text_lang"}))
public class TextPropertyEntity extends AbstractBaseEntity {

	private static final long serialVersionUID = 1L;

	@Column(name = "text_key", nullable = false, length = 256)
	private String key;

	@Column(name = "text_value", nullable = false, length = 2048)
	private String value;

	@Column(name = "text_lang", nullable = false, length = 32)
	private String language;

}
