package edu.kit.scc.webreg.entity.project;

import java.util.Date;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.EnumType;
import jakarta.persistence.Enumerated;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Pattern;

import edu.kit.scc.webreg.entity.AbstractBaseEntity;
import edu.kit.scc.webreg.entity.identity.IdentityEntity;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
@Entity(name = "ProjectInvitationToken")
@Table(name = "project_invitation_token")
public class ProjectInvitationTokenEntity extends AbstractBaseEntity {

	private static final long serialVersionUID = 1L;
	
	@ManyToOne(targetEntity = ProjectEntity.class)
	private ProjectEntity project;

	@NotNull
	@Column(name="invitation_token", length=128, nullable=false, unique=true)
	@Pattern(regexp = "^[a-z0-9-_]{0,63}$")
	private String token;

	@Column(name = "invitation_type")
	@Enumerated(EnumType.STRING)
	private ProjectInvitationType type;

	@Column(name = "invitation_status")
	@Enumerated(EnumType.STRING)
	private ProjectInvitationStatus status;

	@Column(name="rcpt_mail", length=1024)
	private String rcptMail;
	
	@Column(name="rcpt_name", length=1024)
	private String rcptName;

	@ManyToOne(targetEntity = IdentityEntity.class)
	private IdentityEntity identity;

	@ManyToOne(targetEntity = IdentityEntity.class)
	private IdentityEntity invitedIdentity;

	@Column(name="sender_name", length=1024)
	private String senderName;
	
	@Column(name="custom_message", length=1024)
	private String customMessage;
	
	@Column(name="valid_until")
	private Date validUntil;
	
	@Column(name="last_status_change")
	private Date lastStatusChange;
	
}
